/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_GL_PIXELFORMAT_H_
#define MSP_GL_PIXELFORMAT_H_

#include <istream>
#include "gl.h"

namespace Msp {
namespace GL {

enum PixelFormat
{
	COLOR_INDEX     = GL_COLOR_INDEX,
	STENCIL_INDEX   = GL_STENCIL_INDEX,
	DEPTH_COMPONENT = GL_DEPTH_COMPONENT,
	RED             = GL_RED,
	GREEN           = GL_GREEN,
	BLUE            = GL_BLUE,
	ALPHA           = GL_ALPHA,
	RGB             = GL_RGB,
	RGBA            = GL_RGBA,
	BGR             = GL_BGR,
	BGRA            = GL_BGRA,
	LUMINANCE       = GL_LUMINANCE,
	LUMINANCE_ALPHA = GL_LUMINANCE_ALPHA
};

std::istream &operator>>(std::istream &, PixelFormat &);

} // namespace GL
} // namespace Msp

#endif
